xref: /titanic_44/usr/src/cmd/zoneadm/svc-zones (revision e30bbc33865959d55cffa5ae883464a00a60b080)
17c478bd9Sstevel@tonic-gate#!/sbin/sh
27c478bd9Sstevel@tonic-gate#
37c478bd9Sstevel@tonic-gate# CDDL HEADER START
47c478bd9Sstevel@tonic-gate#
57c478bd9Sstevel@tonic-gate# The contents of this file are subject to the terms of the
65cb4571dSdp# Common Development and Distribution License (the "License").
75cb4571dSdp# You may not use this file except in compliance with the License.
87c478bd9Sstevel@tonic-gate#
97c478bd9Sstevel@tonic-gate# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
107c478bd9Sstevel@tonic-gate# or http://www.opensolaris.org/os/licensing.
117c478bd9Sstevel@tonic-gate# See the License for the specific language governing permissions
127c478bd9Sstevel@tonic-gate# and limitations under the License.
137c478bd9Sstevel@tonic-gate#
147c478bd9Sstevel@tonic-gate# When distributing Covered Code, include this CDDL HEADER in each
157c478bd9Sstevel@tonic-gate# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
167c478bd9Sstevel@tonic-gate# If applicable, add the following below this CDDL HEADER, with the
177c478bd9Sstevel@tonic-gate# fields enclosed by brackets "[]" replaced with your own identifying
187c478bd9Sstevel@tonic-gate# information: Portions Copyright [yyyy] [name of copyright owner]
197c478bd9Sstevel@tonic-gate#
207c478bd9Sstevel@tonic-gate# CDDL HEADER END
217c478bd9Sstevel@tonic-gate#
227c478bd9Sstevel@tonic-gate#
235cb4571dSdp# Copyright 2006 Sun Microsystems, Inc.  All rights reserved.
247c478bd9Sstevel@tonic-gate# Use is subject to license terms.
257c478bd9Sstevel@tonic-gate
267c478bd9Sstevel@tonic-gate# ident	"%Z%%M%	%I%	%E% SMI"
277c478bd9Sstevel@tonic-gate#
28*e30bbc33Sdp. /lib/svc/share/smf_include.sh
297c478bd9Sstevel@tonic-gate
307c478bd9Sstevel@tonic-gate[ ! -x /usr/sbin/zoneadm ] && exit 0	# SUNWzoneu not installed
317c478bd9Sstevel@tonic-gate
32*e30bbc33Sdpif [ -z "$SMF_FMRI" ]; then
33*e30bbc33Sdp	echo "this script can only be invoked by smf(5)"
34*e30bbc33Sdp	exit $SMF_EXIT_ERR_NOSMF
35*e30bbc33Sdpfi
36*e30bbc33Sdp
377c478bd9Sstevel@tonic-gate# Make sure working directory is / to prevent unmounting problems.
387c478bd9Sstevel@tonic-gatecd /
397c478bd9Sstevel@tonic-gatePATH=/usr/sbin:/usr/bin; export PATH
407c478bd9Sstevel@tonic-gate
417c478bd9Sstevel@tonic-gatecase "$1" in
427c478bd9Sstevel@tonic-gate'start')
437c478bd9Sstevel@tonic-gate	egrep -vs '^#|^global:' /etc/zones/index || exit 0  # no local zones
447c478bd9Sstevel@tonic-gate	ZONES=""
457c478bd9Sstevel@tonic-gate	for zone in `zoneadm list -pi | nawk -F: '{
467c478bd9Sstevel@tonic-gate			if ($3 == "installed") {
477c478bd9Sstevel@tonic-gate				print $2
487c478bd9Sstevel@tonic-gate			}
497c478bd9Sstevel@tonic-gate		}'`; do
507c478bd9Sstevel@tonic-gate		zonecfg -z $zone info autoboot | grep "true" >/dev/null 2>&1
517c478bd9Sstevel@tonic-gate		if [ $? -eq 0 ]; then
527c478bd9Sstevel@tonic-gate			[ -z "$ZONES" ] && echo "Booting zones:\c"
537c478bd9Sstevel@tonic-gate			ZONES=yes
547c478bd9Sstevel@tonic-gate			echo " $zone\c"
557c478bd9Sstevel@tonic-gate			#
565cb4571dSdp			# zoneadmd puts itself into its own contract so
575cb4571dSdp			# this service will lose sight of it.  We don't
585cb4571dSdp			# support restart so it is OK for zoneadmd to
595cb4571dSdp			# to be in an orphaned contract.
607c478bd9Sstevel@tonic-gate			#
615cb4571dSdp			zoneadm -z $zone boot &
627c478bd9Sstevel@tonic-gate		fi
637c478bd9Sstevel@tonic-gate	done
645cb4571dSdp	#
655cb4571dSdp	# Wait for all zoneadm processes to finish before allowing the
665cb4571dSdp	# start method to exit.
675cb4571dSdp	#
685cb4571dSdp	wait
697c478bd9Sstevel@tonic-gate	[ -n "$ZONES" ] && echo .
707c478bd9Sstevel@tonic-gate	;;
717c478bd9Sstevel@tonic-gate
727c478bd9Sstevel@tonic-gate'stop')
737c478bd9Sstevel@tonic-gate	egrep -vs '^#|^global:' /etc/zones/index || exit 0  # no local zones
747c478bd9Sstevel@tonic-gate	[ "`zoneadm list`" = "global" ] && exit 0   # no zones running
757c478bd9Sstevel@tonic-gate
769e7542f4Sdp	SVC_TIMEOUT=`svcprop -p stop/timeout_seconds $SMF_FMRI`
777c478bd9Sstevel@tonic-gate
789e7542f4Sdp	MAXSHUT=`expr 3 \* $SVC_TIMEOUT \/ 4` # 3/4 of time to zone shutdown
799e7542f4Sdp	MAXHALT=`expr $SVC_TIMEOUT \/ 4`      # rest of time goes to halt
809e7542f4Sdp
819e7542f4Sdp	echo "Shutting down running zones (for up to $MAXSHUT seconds):\c"
827c478bd9Sstevel@tonic-gate
837c478bd9Sstevel@tonic-gate	# First, try letting them run their shutdown scripts.
847c478bd9Sstevel@tonic-gate
857c478bd9Sstevel@tonic-gate	SHUTDOWN=0
867c478bd9Sstevel@tonic-gate	for zone in `zoneadm list`; do
877c478bd9Sstevel@tonic-gate		if [ "$zone" != "global" ]; then
887c478bd9Sstevel@tonic-gate			echo " $zone\c"
897c478bd9Sstevel@tonic-gate			zlogin -S $zone /sbin/init 0 < /dev/null >&0 2>&0 &
907c478bd9Sstevel@tonic-gate			SHUTDOWN=1
917c478bd9Sstevel@tonic-gate		fi
927c478bd9Sstevel@tonic-gate	done
937c478bd9Sstevel@tonic-gate	[ $SHUTDOWN -eq 1 ] && echo "."
947c478bd9Sstevel@tonic-gate
957c478bd9Sstevel@tonic-gate	# Allow time for zones to shutdown cleanly
967c478bd9Sstevel@tonic-gate
977c478bd9Sstevel@tonic-gate	while [ $MAXSHUT -gt 0 -a "`zoneadm list`" != "global" ]; do
987c478bd9Sstevel@tonic-gate		MAXSHUT=`expr $MAXSHUT - 1`
997c478bd9Sstevel@tonic-gate		sleep 1	# wait a bit longer
1007c478bd9Sstevel@tonic-gate	done
1017c478bd9Sstevel@tonic-gate
1027c478bd9Sstevel@tonic-gate	# Second, try halting them.
1037c478bd9Sstevel@tonic-gate
1047c478bd9Sstevel@tonic-gate	WAITPIDS=""
1057c478bd9Sstevel@tonic-gate	for zone in `zoneadm list`; do
1067c478bd9Sstevel@tonic-gate		if [ "$zone" != "global" ]; then
1077c478bd9Sstevel@tonic-gate			[ -z "$WAITPIDS" ] &&
1089e7542f4Sdp			    echo "Zones failed to shutdown; trying to halt " \
1099e7542f4Sdp			    "(for up to $MAXHALT seconds):\c"
1107c478bd9Sstevel@tonic-gate			echo " $zone\c"
1117c478bd9Sstevel@tonic-gate			zoneadm -z $zone halt &
1127c478bd9Sstevel@tonic-gate			WAITPIDS="$WAITPIDS $!"
1137c478bd9Sstevel@tonic-gate		fi
1147c478bd9Sstevel@tonic-gate	done
1157c478bd9Sstevel@tonic-gate	[ ! -z "$WAITPIDS" ] && echo .
1167c478bd9Sstevel@tonic-gate
1177c478bd9Sstevel@tonic-gate	# Wait for the 'zoneadm halt' commands to complete.  We will let this
1187c478bd9Sstevel@tonic-gate	# run forever, since the restart daemon will eventually kill us off
1197c478bd9Sstevel@tonic-gate	# anyway if the halts do not complete after a certain period of time.
1207c478bd9Sstevel@tonic-gate	wait $WAITPIDS
1217c478bd9Sstevel@tonic-gate
1227c478bd9Sstevel@tonic-gate	# If the halts complete but a zone is still not shutdown, it might
1237c478bd9Sstevel@tonic-gate	# be in a state like 'shutting_down' or 'down'.  So we give it some
1247c478bd9Sstevel@tonic-gate	# time to come all the way down.
1257c478bd9Sstevel@tonic-gate	while [ $MAXHALT -gt 0 -a "`zoneadm list`" != "global" ]; do
1267c478bd9Sstevel@tonic-gate		MAXHALT=`expr $MAXHALT - 1`
1277c478bd9Sstevel@tonic-gate		sleep 1	# wait a bit longer
1287c478bd9Sstevel@tonic-gate	done
1297c478bd9Sstevel@tonic-gate
1307c478bd9Sstevel@tonic-gate	#
1317c478bd9Sstevel@tonic-gate	# Report on zones which failed to shutdown.
1327c478bd9Sstevel@tonic-gate	#
1337c478bd9Sstevel@tonic-gate	for zone in `zoneadm list`; do
1347c478bd9Sstevel@tonic-gate		if [ "$zone" != "global" ]; then
1357c478bd9Sstevel@tonic-gate			echo "Zone '$zone' failed to halt."
1367c478bd9Sstevel@tonic-gate		fi
1377c478bd9Sstevel@tonic-gate	done
1387c478bd9Sstevel@tonic-gate	[ "`zoneadm list`" != "global" ] && exit 1   # zones still running
1397c478bd9Sstevel@tonic-gate	;;
1407c478bd9Sstevel@tonic-gate
1417c478bd9Sstevel@tonic-gate*)
1427c478bd9Sstevel@tonic-gate	echo "Usage: $0 { start | stop }"
1437c478bd9Sstevel@tonic-gate	exit 1
1447c478bd9Sstevel@tonic-gate	;;
1457c478bd9Sstevel@tonic-gateesac
1467c478bd9Sstevel@tonic-gateexit 0
147